#!/bin/bash	

#  	grep - awk - sed

#  	SOMMAIRE :
#  	1- Numeroter - compter - additionner - cumuler
#  	2- operations sur les champs : NF
#  	3- operations sur les lignes : NR - occurrences
#  	4- pattern
#  	5- Remplacer des lignes des chiffres ou des lettres
#  	6- Supprimer ou inserer des lignes blanches ,espaces ,tabulations
#  	7- Inserer
#  	8- divers 

###### PARTIE 1-Numeroter - compter - additionner – cumuler
	
#  	Affiche le nombre de lignes (sans les lignes vides) 
#  	awk '/./ {print}' vcluster.csv | wc -l
#  	grep "." vcluster.csv | wc -l 
	
#  	Afficher le numero de chaque ligne 
#  	awk '{print NR,$0}' vcluster.csv  
#  	c=0; while read line; do ((c+=1)); if [ $c -lt 10 ]; then echo 00$c:$line; elif [ $c -lt 100 ]; then echo 0$c:$line; elif [ $c -lt 1000 ]; then echo $c:$line; fi; done < vcluster.csv 
#  	while read line; do N=$((N+1)); echo "Line $N = $line"; done < vcluster.csv 
	
#  	Compte le nombre de lignes vides d'un fichier 
#  	awk '/^$/ {x += 1};END {print x }' vcluster.csv 
	
#  	compter le nombre de lignes et de mots 
#  	awk 'BEGIN{nl=0;nw=0} {nl++;nw+=NF} END {print "lines:",nl, "words:",nw}' vcluster.csv 
	
#  	compter un caractere (ici: i) 
#  	var=`cat vcluster.csv` ; var="${var//[^i]/}" ; echo ${#var} 
	
#  	Compter le nombre d'occurrences de 'pattern' 
#       pattern=Europe;
#  	grep -c "$pattern" vcluster.csv  
#  	awk '/Europe/ {n++} END {print n}' vcluster.csv 
	
#  	Numeroter toutes les lignes contenant 'pattern' (affiche 1 numero par ligne) 
#  	sed -n '/pattern/=' vcluster.csv 
	
#  	Numeroter toutes les lignes entre 2 patterns (affiche 1 numero par ligne) 
##!#  	sed -n '/pattern1/,/pattern2/{=;d;}' vcluster.csv 
	
#  	Ecrire le nom du fichier devant chaque ligne 
#  	grep -H "Europe" vcluster.csv


###### PARTIE 2-Operations sur les champs : NF

#  	Compter le nombre de champs de chaque ligne (separateur = ",") 
#  	awk '{cnt=0 ; for(i=1; i<=NF; i++) {if($i != "") {cnt++}} {print NR " : "cnt" fields"}}' FS="," vcluster.csv 
	
#  	Afficher les 5 premiers caractères de toutes les lignes d'un fichier 
#  	while read line;do echo ${line::5};done < vcluster.csv  
#  	while read line ; do echo $line | cut -c1-5 ; done < vcluster.csv 
	
#  	Supprimer les 5 premiers caracteres de toutes les lignes d'un fichier 
#  	colrm 1 5 < vcluster.csv  
#  	awk 'sub("^.....", "")' vcluster.csv  
#  	while read line ; do echo $line | cut -c6- ; done < vcluster.csv 
	
#  	Afficher les 5 derniers caracteres de toutes les lignes 
#  	sed 's/^.*\(.....\)$/\1/' vcluster.csv  
#  	sed 's/\(.*\)\(.\{5\}\)/\2/' vcluster.csv  
#  	while read line;do echo ${line: -5};done < vcluster.csv  
#  	awk '{print substr($0, length($0) - 4, length($0) ) }' vcluster.csv 
	
#  	Supprimer les 5 derniers caracteres de toutes les lignes 
#  	awk 'sub(".....$", "")' vcluster.csv 
	
#  	Supprimer un champ 
#  	echo "data1 line1" | sed 's/.* //'  
#  	echo "data1 line1" | sed -n 's/.* //;p'  
#  	resultat: line1 
	
#  	Supprimer le dernier champ 
#  	awk '{$NF=""; print $0}' vcluster.csv 
	
#  	Champ tampon 'elapse' pour operations intermediaires 
##!#  	awk '{elapse = $1/3600; if(elapse<8) print int($1/3600)}' vcluster.csv 
	
#  	Dans champ 1, a la position 2, printer 3 caracteres 
#  	awk '{print substr($1,2,3)}' vcluster.csv 
	
#  	Afficher l'avant dernier champ ($NF-1) de chaque ligne 
#  	awk '{print $(NF-1)}' vcluster.csv
#       awk -F ',' '{print $(NF-3)}'  vcluster.csv | head -n 5


###### PARTIE 3-operations sur les lignes : occurrences - digits - suppression - doubles – printer 

#  	Occurrences : Compter les occurrences d'un pattern (total cumule) 
#  	awk '/pattern/ {n++} END {print "pattern ecrit" n "fois"}' vcluster.csv 
##    grep -c Europe vcluster.csv (pas si 2 fois dans la meme ligne)
	
#  	Occurrences : Remplacer la 2ème occurrence d'un pattern de la premiere ligne 
#  	sed '0,/old/ s//new/2' vcluster.csv 
	
#  	Digits : Afficher les 4 derniers caracteres de chaque ligne 
#  	awk '{print substr($0, length($0)-3, length($0))}' vcluster.csv 
	
#  	Digits : Printer 6 catarceres à partir du 2ème digit 
#  	while read line; do echo `expr substr "$line" 2 6`; done < vcluster.csv 
	
#  	Suppression de lignes : Supprime 'toto' de la ligne 2 a 6 
#  	sed -e '2,6 s/toto//g' vcluster.csv 
	
#  	Suppression de lignes : Supprime la ligne debutant par '@' et les 2 suivantes 
###!#  	sed '/^@/ {N;N;d;}' vcluster.csv 
	
#  	Suppression de lignes : Supprimer les lignes 1, 4, 7, 10..... 
#  	sed -e '1~3d' vcluster.csv 
	
#  	Suppression de lignes : Supprimer les 10 dernieres lignes 
#  	sed -e :a -e '$d;N;2,10ba' -e 'P;D'  
#  	sed -n -e :a -e '1,10!{P;N;D;};N;ba' 
	
#  	Lignes doubles : Afficher les lignes uniques sans les doubles 
#  	sort -u vcluster.csv  
#  	sort vcluster.csv | uniq  
#  	awk '!x[$0]++' vcluster.csv  
#  	awk '{ a[$1]++ } END {for (i in a) print i}' vcluster.csv | sort  
#  	sed '$!N; /^\(.*\)\n\1$/!P; D' vcluster.csv .........consecutive lines 
	
#  	Lignes doubles : Afficher les lignes doubles , Supprimer le reste 
#  	awk 'x[$0]++' vcluster.csv  
#  	cat vcluster.csv | uniq -d  
#  	sed '$!N; s/^\(.*\)\n\1$/\1/; t; D' vcluster.csv 
	
#  	Lignes doubles : Afficher les lignes doubles (ou triples ...) 
#  	awk 'FNR==NR && a[$0]++ {b[$0] ; next} $0 in b' vcluster.csv vcluster.csv 
	
#  	Printer des lignes  Printer de la ligne 3 a 5 
#  	sed '3,5!d' vcluster.csv  
#  	sed -n '3,5p' vcluster.csv  
#  	awk 'NR >= 3 && NR <= 5' vcluster.csv  
#  	head -5 vcluster.csv | tail -3  
#  	sed -n '3{:a;N;5!ba;p}' vcluster.csv 
		
	
###### PARTIE 4-pattern 

#  	Capture d'un pattern dans 1 fichier 
#  	grep 'pattern' vcluster.csv  
#  	grep -w 'pattern' vcluster.csv  
#  	awk '/pattern/' vcluster.csv  
#  	awk '$0 ~ /\ypattern\y/ {print}' vcluster.csv  
#  	sed -n '/pattern/p' vcluster.csv  
#  	sed '/pattern/ !d' vcluster.csv  
#  	grep '\<pattern\>' vcluster.csv 
	
#  	Afficher les lignes ne contenant que des chiffres 
#  	sed -n '/^[[:digit:]]*$/p' vcluster.csv 
	
#  	Afficher les lignes ne contenant que des lettres 
#  	sed -n '/^[[:alpha:]]*$/p' vcluster.csv 
	
#  	Capture d'un pattern dans plusieurs fichiers 
#  	grep "pattern" in*.txt  for i in in*.txt;do seq=`ls $i`;awk '/pattern/ {print seq,$0}' seq=${seq} $i;done 
	grep -R "id\," .

#  	Afficher un paragraphe separe par des lignes blanches , contenant un pattern 
#  	sed -e '/./{H;$!d;}' -e 'x;/pattern/!d;' vcluster.csv 
	
#  	Afficher un paragraphe separe par des lignes blanches , contenant pattern1 'et' pattern2 
#  	sed -e '/./{H;$!d;}' -e 'x;/pattern1/!d;/pattern2/!d' vcluster.csv 
	
#  	Afficher un paragraphe separe par des lignes blanches , contenant pattern1 'ou' pattern2 
#  	sed -e '/./{H;$!d;}' -e 'x;/pattern1/b' -e '/pattern2/b' -e d vcluster.csv 
	
#  	Capturer dans la colonne 1 le pattern '2' et Afficher la colonne 3 
#  	awk '$1 ~ /2/ {print $3}' vcluster.csv  
#  	awk '$1 == "2" {print $3}' vcluster.csv  
#  	awk '{if($1 ~ /t/){gsub(/t/, "z",$1);print $0}}' vcluster.csv  
#  	awk '$1 !~ /2/ {print $3}' vcluster.csv ........... #syntaxe inverse  
#  	awk '$1 \!~ /2/ {print $3}' vcluster.csv ...........#syntaxe inverse (selon version Linux) 
	
#  	Supprimer les lignes contenant des patterns 
#  	awk '$1 !~ /pattern1/ && $2 !~ /pattern2/ ' vcluster.csv  
#  	awk '$1 ~ /pattern1/ || $2 ~ /pattern2/ {next} {print}' vcluster.csv 
	
#  	Capturer le caractère # à la 4ème position 
#  	egrep '^.{3}#' vcluster.csv 
#####!       egrep '^.{3,5}i' vcluster.csv | head -n 5
	
#  	Capturer les lignes commencant par 1 espace ou plus, sans celles commencant par 2 espaces 
#  	grep "[ ]\{1\}" vcluster.csv | awk '$0 !~ /^ / {print}' 
###!#  grep "[ ]\{1\}" vcluster.csv
	
	
	
###### PARTIE 5-Remplacer des lignes des chiffres ou des lettres 
 
#  	Exemple d'une suite d'actions entre 2 patterns 
#  	sed -n '4,10 {/pattern1/,/pattern2/ {s/^0./y&/;/^$/d;s/m/w/g;p}}' vcluster.csv 
	
#  	Supprimer tous les chiffres en gardant un tiret '-' a la place 
#  	tr -d 0-9 < vcluster.csv 
	
#  	supprimer toutes les lettres en gardant un tiret '-' a la place 
#  	tr -d [a-zA-Z] < vcluster.csv 
	
#  	Conserver les lignes contenant des chiffres 
#  	sed -e '/[0-9]/!d' vcluster.csv  
#  	sed -e '/[0-9]/\!d' vcluster.csv 
	
#  	Changer un texte majuscule en minuscule 
#  	awk '{print tolower($0)}' vcluster.csv  
#  	cat vcluster.csv | tr -s A-Z a-z 
	
#  	Changer un texte minuscule en majuscule 
#  	cat vcluster.csv | tr -s a-z A-Z 
	
#  	Supprimer les lettres minuscules en fin de ligne 
#  	awk '{ sub("[a-z]*$", ""); print }' vcluster.csv 
	
#  	Afficher le pattern sans distinguer majuscules ou minuscules 
#  	grep -i "pattern" vcluster.csv 
	
#  	Mettre en majuscule la 1ère lettre d'une phrase 
#  	echo -e "texte ligne1\ntexte ligne2" | sed 's/^./\u&/' 
	
#  	Remplacer les lettres par une operande (ici: +) 
#  	cat vcluster.csv | tr '[:alpha:]' + 
	
#  	Remplacer les chiffres par une operande (ici: +) 
#  	cat vcluster.csv | tr '[:digit:]' + 
	
	
	
###### PARTIE 6-Supprimer des lignes blanches ,espaces ,tabulations 

#  	Supprimer les lignes blanches (l'option '-i' reecrit directement dans le fichier , l'option '-i' est a manier avec precaution) 
#  	sed '/./!d' vcluster.csv  
#  	sed -i '/^$/d' vcluster.csv 
	
#  	Supprimer les lignes blanches repetees sauf la 1ere 
#  	cat -s vcluster.csv 
	
#  	Supprimer uniquement les lignes blanches du debut du fichier 
#  	sed '/./,$!d' vcluster.csv 
	
#  	Supprimer tout ce qui suit la 1ere ligne blanche 
#  	sed '/^$/q' vcluster.csv 
	
#  	Supprimer tout ce qui precede la 1ere ligne blanche 
#  	sed '1,/^$/d' vcluster.csv 
	
#  	Supprimer les lignes blanches entre 'tata' et 'route' 
#  	sed -e '/tata/,/route/ {/^$/d}' vcluster.csv 
	
#  	Remplacer 2 blancs (ou +) par 1 seul blanc 
#  	sed 's/\ \ */\ /g' vcluster.csv 
	
#  	Suppression des espaces et tabulations en debut et fin de ligne 
#  	sed 's/^[ \t]*//;s/[ \t]*$//' vcluster.csv 
	
#  	Suppression des lignes vides 
#  	grep -v '^$' vcluster.csv  
#  	grep '.' vcluster.csv  
#  	sed -n '/^$/!p' vcluster.csv  
#  	awk NF vcluster.csv  
#  	awk '/./' vcluster.csv  
#  	sed '/^$/d' vcluster.csv  
#  	sed '/./!d' vcluster.csv  
#  	awk '/^$/ {next} {print}' vcluster.csv 
	
#  	tr + option squeeze-repeats: efface tout sauf la première  : occurence d'une chaîne de caractères  (utile pour supprimer plusieurs espaces blancs) 
#  	echo "XXXXX" | tr --squeeze-repeats 'X' ....... resultat: X 
	
#  	Supprime tous les espaces au début de toutes les lignes 
#  	sed 's/^ *//g' vcluster.csv 
	
#  	Supprime tous les espaces à la fin de toutes les lignes 
#  	sed 's/ *$//g' vcluster.csv 
	
	
	
###### PARTIE 7-Inserer 

#  	Inserer une ligne blanche apres chaque ligne 
#  	sed G vcluster.csv  
#  	sed 'a\ ' vcluster.csv 
	
#  	Inserer une ligne de tirets toutes les 2 lignes 
#  	sed 'n;a\----------' vcluster.csv 
	
#  	Inserer une ligne blanche toutes les 3 lignes 
#  	sed 'n;n;G;' vcluster.csv 
	
#  	Inserer une ligne blanche apres chaque ligne sauf apres la ligne 3 
#  	sed '3!G' vcluster.csv 
	
#  	Inserer une ligne au debut, à la 3eme ligne et à la fin du fichier 
#  	sed -e '1i \debut\ du\ traitement' vcluster.csv  
#  	sed -e '3i \ajout\ a\ la\ 3eme\ ligne' vcluster.csv  
#  	awk 'NR == 3 {print "line3"}1' vcluster.csv  
#  	sed -e '$a \fin\ du\ traitement' vcluster.csv 
	
#  	Inserer une ligne à un pattern 
#  	sed -e '/pattern/ i\ligne ecrite avant le pattern' vcluster.csv ............ (option 'i' : avant le pattern)  
#  	sed -e '/pattern/ a\ligne ecrite apres le pattern' vcluster.csv ## ............ (option 'a' : apres le pattern) 
	
#  	Inserer une ligne blanche à un pattern 
#  	sed -e '/pattern/ i\ ' vcluster.csv ## ............ (option 'i' : avant le pattern)  
#  	sed -e '/pattern/ a\ ' vcluster.csv ## ............ (option 'a' : apres le pattern) 
	
#  	Changer la ligne si elle contient un pattern 
#  	sed -e '/pattern/ c\new line' vcluster.csv 
	
#  	Inserer **DELETED** et supprimer les lignes entre 2 patterns 
#  	sed '/pattern1/,/pattern2/ c\**DELETED**' vcluster.csv 
	
#  	Inserer la ligne 'line before' avant chaque ligne du fichier 
#  	sed -e 'i\line before' vcluster.csv 
	
#  	Inserer du texte avant une ligne matchée par un pattern 
#  	sed -e '/pattern/ i\line before pattern' vcluster.csv 
	
	
	
###### PARTIE 8-divers

#  	Retirer les accents d'un texte 
#  	cat non-ascii.txt | iconv -f utf8 -t ascii//TRANSLIT//IGNORE > ascii.txt 
	
#  	Afficher les lignes d'un fichier2 qui ne sont pas dans le fichier1 
#  	comm -23 file2.txt file1.txt 2>dev  
#  	grep -vxFf file1.txt file2.txt 
	
#  	Afficher un fichier 
#  	cat vcluster.csv  
#  	sed '' vcluster.csv  
#  	sed ':' vcluster.csv 
	
#  	Dupliquer toutes les lignes 
#  	sed 'p' vcluster.csv 
	
#  	printer 3 fois chaque ligne 
#  	sed '{h;p;p}' vcluster.csv  
#  	while read line;do for i in `seq 1 3`;do echo $line;done;done < vcluster.csv 
	
#  	Inverser l'ordre d'un fichier 
#  	tac vcluster.csv  
#  	sed -n '1!G;h;$p' vcluster.csv  
#  	awk '{ a[i++]=$0 } END { for (j=i-1; j>=0; ) print a[j--] }' vcluster.csv 
	
#  	Ecrire 1 mot par ligne (pour 5 mots: -n5) 
#  	cat vcluster.csv | xargs -n1  awk '{i=1; while (i<=NF){print $i, " ";i++}}' vcluster.csv 
	
#  	Ecrire un caractère par ligne 
#  	while read line; do echo -n "$line" | dd cbs=1 conv=unblock 2>/dev/null; done < vcluster.csv 
	
#  	Ecrire un fichier sur une ligne 
#  	sed '{:a;$!N;s_\n_ _;ta}' vcluster.csv 
	
#  	Joindre les lignes paires a la suite des lignes impaires 
#  	sed '$!N; s/\n/ /g' vcluster.csv 
	
#  	Transforme les lignes en colonnes 
#  	awk '{printf "ligne%d: %s ",NR,$0>"z-cible"}' z-source 

